unit Adrbku2;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, OvcPb, OvcPf, OvcSc, OvcBase, OvcEf, OvcSf, OvcData,
  StdCtrls, Buttons, ExtCtrls, Adrbku4, CalUnit, OvcMisc, OVCDT;

const
  MaxNotesSize = 255;

type
  PAddressRec = ^TAddressRec;
  TAddressRec = record
    Last     : string[15];
    First    : string[15];
    Company  : string[30];
    Address  : string[30];
    City     : string[30];
    State    : string[2];
    Zip      : string[10];
    HPhone   : string[14];
    WPhone   : string[14];
    Birthday : TOvcDate;
    Anniv    : TOvcDate;
    Notes    : array[0..MaxNotesSize] of Char;
  end;

type
  TfrmEdit = class(TForm)
    edLast: TOvcSimpleField;
    edFirst: TOvcSimpleField;
    edCompany: TOvcSimpleField;
    edAddress: TOvcSimpleField;
    edCity: TOvcSimpleField;
    edState: TOvcSimpleField;
    OvcSpinner1: TOvcSpinner;
    edZip: TOvcPictureField;
    edHomePhone: TOvcPictureField;
    edWorkPhone: TOvcPictureField;
    edBirth: TOvcPictureField;
    edAnniv: TOvcPictureField;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    btnOK: TBitBtn;
    btnCancel: TBitBtn;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    pnlHints: TPanel;
    btnNotes: TBitBtn;
    OvcStarSpinner1: TOvcStarSpinner;
    OvcStarSpinner2: TOvcStarSpinner;
    OvcController1: TOvcController;
    procedure ShowHint(Sender: TObject);
    procedure btnNotesClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure OvcStarSpinner1Click(Sender: TObject; State: TSpinState;
      Delta: Double; Wrap: Boolean);
    procedure OvcStarSpinner2Click(Sender: TObject; State: TSpinState;
      Delta: Double; Wrap: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure PopupCal(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    function CanWeClose : Boolean;
    procedure ClearFields;
    procedure SetFields(R : PAddressRec);
    procedure GetFields(R : PAddressRec);
  end;

var
  frmEdit: TfrmEdit;

implementation

{$R *.DFM}

function TfrmEdit.CanWeClose : Boolean;
var
  S : string;
begin
  Result := True;

  if (not edBirth.IsValid) and edBirth.EverModified then begin
    S := ' ';{!!}
    edBirth.SetFocus;
  end else if (not edAnniv.IsValid) and edAnniv.EverModified then begin
    S := ' ';{!!}
    edAnniv.SetFocus;
  end else if edLast.AsString <> '' then
    Exit
  else if edFirst.AsString <> '' then
    Exit
  else if edCompany.AsString <> '' then
    Exit
  else begin
    S := 'First three fields are all empty. At least one must contain text.';
    edLast.SetFocus;
  end;

  MessageDlg(S, mtWarning, [mbOk], 0);
  Result := False;
end;

procedure TfrmEdit.ClearFields;
begin
  edLast.AsString := '';
  edFirst.AsString := '';
  edCompany.AsString := '';
  edAddress.AsString := '';
  edCity.AsString := '';
  edState.AsString := '';
  edZip.AsString := '';
  edHomePhone.AsString := '';
  edWorkPhone.AsString := '';
  edBirth.AsOvcDate := BadDate;
  edAnniv.AsOvcDate := BadDate;
{!!notes}
end;

procedure TfrmEdit.SetFields(R : PAddressRec);
begin
  with R^ do begin
    edLast.AsString := Last;
    edFirst.AsString := First;
    edCompany.AsString := Company;
    edAddress.AsString := Address;
    edCity.AsString := City;
    edState.AsString := State;
    edZip.AsString := Zip;
    edHomePhone.AsString := HPhone;
    edWorkPhone.AsString := WPhone;
    edBirth.AsOvcDate := Birthday;
    edAnniv.AsOvcDate := Anniv;
  {!!notes}
  end;
end;

procedure TfrmEdit.GetFields(R : PAddressRec);
begin
  with R^ do begin
    Last := edLast.AsString;
    First := edFirst.AsString;
    Company := edCompany.AsString;
    Address := edAddress.AsString;
    City := edCity.AsString;
    State := edState.AsString;
    Zip := edZip.AsString;
    HPhone := edHomePhone.AsString;
    WPhone := edWorkPhone.AsString;
    Birthday := edBirth.AsOvcDate;
    Anniv := edAnniv.AsOvcDate;
{!!notes}
  end;
end;

procedure TfrmEdit.ShowHint(Sender: TObject);
begin
  pnlHints.Caption := (Sender as TControl).Hint;
end;

procedure TfrmEdit.btnNotesClick(Sender: TObject);
begin
  frmNotes := TfrmNotes.Create(Self);
  try
    frmNotes.SetEditorLimit(MaxNotesSize);
    {!!}
    frmNotes.ShowModal;
    if frmNotes.ModalResult = idOK then begin
    {!!}
    end;
  finally
    frmNotes.Free;
  end;
end;

procedure TfrmEdit.FormShow(Sender: TObject);
begin
  edLast.SetFocus;
end;

procedure TfrmEdit.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if ModalResult = idOK then
    CanClose := CanWeClose;
end;

procedure TfrmEdit.OvcStarSpinner1Click(Sender: TObject; State: TSpinState;
  Delta: Double; Wrap: Boolean);
var
  D : TOvcDate;
begin
  if State = ssCenterBtn then begin
    CalForm := TCalForm.Create(Application);
    try
      D := edBirth.AsOvcDate;
      if D = BadDate then
        D := CurrentDate;
      CalForm.OvcCalendar1.CalendarDate := D;
      CalForm.ShowModal;
      if CalForm.ModalResult = idOK then begin
        edBirth.AsOvcDate := CalForm.OvcCalendar1.CalendarDate;
        edBirth.Uninitialized := False;
      end;
    finally
      CalForm.Free;
    end;
  end;
end;

procedure TfrmEdit.OvcStarSpinner2Click(Sender: TObject; State: TSpinState;
  Delta: Double; Wrap: Boolean);
var
  D : TOvcDate;
begin
  if State = ssCenterBtn then begin
    CalForm := TCalForm.Create(Application);
    try
      D := edAnniv.AsOvcDate;
      if D = BadDate then
        D := CurrentDate;
      CalForm.OvcCalendar1.CalendarDate := D;
      CalForm.ShowModal;
      if CalForm.ModalResult = idOK then begin
        edAnniv.AsOvcDate := CalForm.OvcCalendar1.CalendarDate;
        edAnniv.Uninitialized := False;
      end;
    finally
      CalForm.Free;
    end;
  end;
end;

procedure TfrmEdit.FormCreate(Sender: TObject);
begin
  with edBirth do
    PictureMask := IntlSupport.InternationalDate(True);
  with edAnniv do
    PictureMask := IntlSupport.InternationalDate(True);
end;

procedure TfrmEdit.PopupCal(Sender: TObject);
var
  PF : TOvcPictureField;
  D  : TOvcDate;
begin
  CalForm := TCalForm.Create(Application);
  try
    PF := (Sender as TOvcPictureField);
    D := PF.AsOvcDate;
    if D = BadDate then
      D := CurrentDate;
    CalForm.OvcCalendar1.CalendarDate := D;
    CalForm.ShowModal;
    if CalForm.ModalResult = idOK then begin
      PF.AsOvcDate := CalForm.OvcCalendar1.CalendarDate;
      PF.Uninitialized := False;
    end;
  finally
    CalForm.Free;
  end;
end;

end.
