
{sample descendant component based on a picture entry field component}

unit ExComp;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, OvcBase, OvcEf, OvcPb, OvcPf, OvcData;

const
{ DefDateOptions = [pefBeepOnError,pefSoftValidation,pefStripLiterals];}

  {excluded soft validation so we can see if errors are trapped}
  DefDateOptions = [pefBeepOnError,pefStripLiterals];

type
  TMyDateField = class(TOvcPictureField)
  private
    { Private declarations }
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(AOwner : TComponent); override;
  published
    { Published declarations }
  end;

procedure Register;


implementation

constructor TMyDateField.Create(AOwner : TComponent);
begin
  inherited Create(AOwner);

  {if pefFixedFont is in Options, this won't make any difference}
  {unless the parent is using a fixed font}
  ParentFont := True;

  {set the field type}
  FieldType := pftDate;

  {used fixed picture mask vs international for simplicity}
  PictureMask := 'mm/dd/yyyy';

  {set max length since it only gets reset if the new mask is larger}
  {than the current max length}
  MaxLength := StrLen(efPicture);

  {set our default options}
  Options := DefDateOptions;

  {set range values}
  RangeLo := '01/01/1600';
  RangeHi := '12/31/3999';
end;

procedure Register;
begin
  RegisterComponents('Examples', [TMyDateField]);
end;

end.
