unit ExTranU;

interface

uses
  WinTypes, WinProcs, WinCrt, Messages, Classes, Graphics,
  Controls, Forms, Dialogs, ExtCtrls, StdCtrls, Buttons, SysUtils,
  OvcXfer, OvcPb, OvcPf, OvcBase, OvcData, OvcDT, OvcEf, OvcSf;

type
  {transfer buffer for the Form1 form}
  TForm1TransferRec = record
    Label1Text            : string;
    Edit1Text             : string;
    CheckBox1Checked      : Boolean;
    RadioButton1Checked   : Boolean;
    OvcPictureField1Value : TOvcDate;
    ListBox1Items         : TStrings;
    ListBox1ItemIndex     : Integer;
    ComboBox1Items        : TStrings;
    ComboBox1Text         : string;
    Panel1Text            : string;
  end;

type
  TForm1 = class(TForm)
    OvcTransfer1: TOvcTransfer;
    Button1: TButton;
    DefaultController: TOvcController;
    Label1: TLabel;
    Edit1: TEdit;
    CheckBox1: TCheckBox;
    RadioButton1: TRadioButton;
    OvcPictureField1: TOvcPictureField;
    ListBox1: TListBox;
    ComboBox1: TComboBox;
    Panel1: TPanel;
    Button2: TButton;
    BitBtn1: TBitBtn;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
    Rec : TForm1TransferRec;
    procedure InitForm1Transfer(var Data : TForm1TransferRec);
      {-initialize transfer buffer}
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.InitForm1Transfer(var Data : TForm1TransferRec);
  {-initialize transfer buffer}
begin
  with Data do begin
    Label1Text            := 'Label text';
    Edit1Text             := 'Edit text';
    CheckBox1Checked      := True;
    RadioButton1Checked   := False;
    OvcPictureField1Value := CurrentDate;
    ListBox1Items         := TStringList.Create;
    with ListBox1Items do begin
      Add('LB Item 1');
      Add('LB Item 2');
      Add('LB Item 3');
    end;
    ListBox1ItemIndex     := 1;
    ComboBox1Items        := TStringList.Create;
    with ComboBox1Items do begin
      Add('CB Item 1');
      Add('CB Item 2');
      Add('CB Item 3');
    end;
    ComboBox1Text         := 'Combobox Text';
    Panel1Text            := 'Panel Text';
  end; {with}
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  {create transfer objects and init transfer record}
  InitForm1Transfer(Rec);
  {transfer data to the form}
  {the below component order must match the transfer record}
  {definition!}
  OvcTransfer1.TransferToForm(
    [Label1, Edit1, CheckBox1, RadioButton1, OvcPictureField1,
     Listbox1, ComboBox1, Panel1], Rec);
  {free objects within the transfer buffer}
  Rec.Listbox1Items.Free;
  Rec.Combobox1Items.Free;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  I : Integer;
begin
  {create transfer objects and init transfer record}
  InitForm1Transfer(Rec);
  {transfer data from the form}
  {normally, you would not wish to retrieve the contents}
  {of static components (Label, Panel, ...) }
  OvcTransfer1.TransferFromForm(
    [Label1, Edit1, CheckBox1, RadioButton1, OvcPictureField1,
     Listbox1, ComboBox1, Panel1], Rec);

  {display returned data}
  WriteLn('Data returned from the form');
  WriteLn;
  with Rec do begin
    WriteLn(Label1.Name:30, ' >> ', Label1Text);
    WriteLn(Edit1.Name:30, ' >> ', Edit1Text);
    WriteLn(Checkbox1.Name:30, ' >> ', CheckBox1Checked);
    WriteLn(RadioButton1.Name:30, ' >> ', RadioButton1Checked);
    WriteLn(OvcPictureField1.Name:30, ' >> ', OvcPictureField1Value);
    WriteLn(ListBox1.Name:21, 'ItemIndex >> ', ListBox1ItemIndex);
    for I := 0 to ListBox1.Items.Count-1 do
      WriteLn(ListBox1.Name:27,'[',I,'] >> ', ListBox1Items[I]);
    WriteLn(Combobox1.Name:26, 'Text >> ', ComboBox1Text);
    for I := 0 to ComboBox1Items.Count-1 do
      WriteLn(ComboBox1.Name:27,'[',I,'] >> ', ComboBox1Items[I]);
    WriteLn(Panel1.Name:30, ' >> ', Panel1Text);
  end;

  {free objects within the transfer buffer}
  Rec.Listbox1Items.Free;
  Rec.Combobox1Items.Free;
end;

end.


