{$B-} {Complete Boolean Evaluation}
{$G+} {286 Instructions}
{$I+} {Input/Output-Checking}
{$N+} {Numeric Coprocessor}
{$P+} {Open Parameters}
{$T-} {Typed @ Operator}
{$W-} {Windows Stack Frame}
{$X+} {Extended Syntax}

{$C MOVEABLE,DEMANDLOAD,DISCARDABLE}

{*********************************************************}
{*                  OVCREGDB.PAS 1.00                    *}
{*       Copyright (c) TurboPower Software Co 1995       *}
{*                 All rights reserved.                  *}
{*********************************************************}

unit OvcRegDb;

interface

uses
  WinTypes, DsgnIntf, Classes;

procedure Register;

implementation

uses
  OvcVer,
  OvcEfPe,   {range property editor}
  OvcSfPE,   {simple mask property editor form}
  OvcPfPE,   {picture mask property editor form}
  OvcNfPE,   {numeric mask property editor}
  OvcDbSf,   {data aware simple field}
  OvcDbPf,   {data aware picture field}
  OvcDbNf,   {data aware numeric field}
  OvcDbEd;   {data aware editor}
(*
  WinProcs, SysUtils, Dialogs, Forms, Graphics,
  OvcEf,     {base entry field class--needed for sf, pf, nf, and ae}
  OvcSf,     {simple field component}
  OvcPf,     {picture field component}
  OvcNf,     {numeric entry field component}
  OvcAe,     {array editors}
  OvcAePe,   {range property editor}
  OvcVlb,    {virtual list box component}
  OvcNbk,    {notebook component}
  OvcNbkP0,  {property editor for the notebook pages}
  OvcCal,    {calendar component}
  OvcViewr,  {viewer and text file viewer components}
  OvcMeter,  {meter component}
  OvcSc,     {spin components}
  OvcScPE,   {spin components component editor}
  OvcTimer,  {timer pool}
  OvcRLbl,   {rotated label component}
  OvcEdit,   {editor and text editor components}
  OvcXfer,   {form data transfer component}
  OvcXfrC0,  {transfer component component editor}
  OvcFxFnt,  {fixed font class}
  OvcFxFPE,  {fixed font property editor}
  OvcBase, OvcCmd, OvcCmdP0, OvcData, OvcVer;  {all required}
*)

{*** component registration ***}

procedure Register;
begin
  {register property editors for the data aware entry fields}
  RegisterPropertyEditor(
    TypeInfo(Char), TOvcDbSimpleField, 'PictureMask', TSimpleMaskProperty);
  RegisterPropertyEditor(
    TypeInfo(string), TOvcDbPictureField, 'PictureMask', TPictureMaskProperty);
  RegisterPropertyEditor(
    TypeInfo(string), TOvcDbNumericField, 'PictureMask', TNumericMaskProperty);
  RegisterPropertyEditor(
    TypeInfo(string), TOvcDbSimpleField, 'RangeHi', OvcEfPe.TEfRangeProperty);
  RegisterPropertyEditor(
    TypeInfo(string), TOvcDbSimpleField, 'RangeLo', OvcEfPe.TEfRangeProperty);
  RegisterPropertyEditor(
    TypeInfo(string), TOvcDbPictureField, 'RangeHi', OvcEfPe.TEfRangeProperty);
  RegisterPropertyEditor(
    TypeInfo(string), TOvcDbPictureField, 'RangeLo', OvcEfPe.TEfRangeProperty);
  RegisterPropertyEditor(
    TypeInfo(string), TOvcDbNumericField, 'RangeHi', OvcEfPe.TEfRangeProperty);
  RegisterPropertyEditor(
    TypeInfo(string), TOvcDbNumericField, 'RangeLo', OvcEfPe.TEfRangeProperty);

  {register DB components}
  RegisterComponents(ProductName + ' (DB)',
    [TOvcDbSimpleField,
     TOvcDbPictureField,
     TOvcDbNumericField,
     TOvcDbEditor
    ]);
end;

end.
