{$B-} {Complete Boolean Evaluation}
{$G+} {286 Instructions}
{$I+} {Input/Output-Checking}
{$N+} {Numeric Coprocessor}
{$P+} {Open Parameters}
{$T-} {Typed @ Operator}
{$W-} {Windows Stack Frame}
{$X+} {Extended Syntax}

{$C MOVEABLE,DEMANDLOAD,DISCARDABLE}

{*********************************************************}
{*                  OVCREGTB.PAS 1.00                    *}
{*         Copyright (c) TurboPower Software 1995        *}
{*                 All rights reserved.                  *}
{*********************************************************}

unit OvcRegTb;

interface

uses
  WinTypes, Classes, DsgnIntf;


procedure Register;

implementation

uses
  OvcEFPE, OvcSFPE, OvcPFPE, OvcNFPE,
  OvcTable,
  OvcTbPE1,
  OvcTbPE2,
  OvcTbRws,
  OvcTCEdt,
  OvcTCHdr,
  OvcTCBmp,
  OvcTCGly,
  OvcTCBox,
  OvcTCSim,
  OvcTCPic,
  OvcTCNum,
  OvcVer;

{*** component registration ***}


procedure Register;
begin
  RegisterPropertyEditor(
    TypeInfo(TOvcTableRows), nil, '', TOvcTableRowProperty);

  RegisterPropertyEditor(
    TypeInfo(TOvcTableColumns), nil, '', TOvcTableColumnProperty);

  {register property editors for the cell entry fields}
  RegisterPropertyEditor(
    TypeInfo(Char), TOvcTableCellSimpleField, 'PictureMask', TSimpleMaskProperty);
  RegisterPropertyEditor(
    TypeInfo(string), TOvcTableCellPictureField, 'PictureMask', TPictureMaskProperty);
  RegisterPropertyEditor(
    TypeInfo(string), TOvcTableCellNumericField, 'PictureMask', TNumericMaskProperty);
  RegisterPropertyEditor(
    TypeInfo(string), TOvcTableCellSimpleField, 'RangeHi', OvcEfPe.TEfRangeProperty);
  RegisterPropertyEditor(
    TypeInfo(string), TOvcTableCellSimpleField, 'RangeLo', OvcEfPe.TEfRangeProperty);
  RegisterPropertyEditor(
    TypeInfo(string), TOvcTableCellPictureField, 'RangeHi', OvcEfPe.TEfRangeProperty);
  RegisterPropertyEditor(
    TypeInfo(string), TOvcTableCellPictureField, 'RangeLo', OvcEfPe.TEfRangeProperty);
  RegisterPropertyEditor(
    TypeInfo(string), TOvcTableCellNumericField, 'RangeHi', OvcEfPe.TEfRangeProperty);
  RegisterPropertyEditor(
    TypeInfo(string), TOvcTableCellNumericField, 'RangeLo', OvcEfPe.TEfRangeProperty);

  RegisterComponents(ProductName + ' (Table)',
    [TOvcTable,
     TOvcTableCellString,
     TOvcTableCellColHead,
     TOvcTableCellRowHead,
     TOvcTableCellGlyph,
     TOvcTableCellCheckBox,
    (*OvcTableCellComboBox,*)
     TOvcTableCellSimpleField,
     TOvcTableCellPictureField,
     TOvcTableCellNumericField]);
end;

end.
