unit Testform;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Menus,
  OvcTCmmn, OvcTable, OvcTGRes, ExtCtrls, OvcCal, Grids, OvcBase,
  OvcTCEdt, OvcTCHdr, OvcTCGly, OvcTCBmp, OvcTCBox, OvcEf, OvcSf, OvcTCSim,
  OvcPb, OvcPf, OvcTCPic, OvcNf, OvcTCNum;

type
  TForm1 = class(TForm)
    OvcTableCellColHead1: TOvcTableCellColHead;
    OvcTableCellRowHead1: TOvcTableCellRowHead;
    OvcTableCellString1: TOvcTableCellString;
    OvcTable1: TOvcTable;
    OvcTableCellGlyph2: TOvcTableCellGlyph;
    OvcTableCellCheckBox1: TOvcTableCellCheckBox;
    OvcTableCellSimpleField1: TOvcTableCellSimpleField;
    OvcTableCellSimpleField2: TOvcTableCellSimpleField;
    OvcTableCellPictureField1: TOvcTableCellPictureField;
    OvcTableCellNumericField1: TOvcTableCellNumericField;
    Button1: TButton;
    OvcTableCellString2: TOvcTableCellString;
    OvcController1: TOvcController;
    procedure OvcTable1GetCellData(Sender: TObject; RowNum: Longint;
      ColNum: Integer; var Data: Pointer);
    procedure RowModeClick(Sender: TObject);
    procedure OvcTable1GetCellColor(Sender: TObject; RowNum: Longint;
      ColNum: Integer; var Color: TColor);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
    CellData : string;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

type
  TTestRec = record
    Name  : string[49];
    CHBox : TCheckBoxState;
    Suit  : integer;
    Simp  : string[19];
    Simp2 : integer;
    Phone : string[11];
    Age   : longint;
  end;
  TTestDataBase = array [1..9] of TTestRec;

const
  TestDatabase : TTestDataBase = (
    (Name:'Bucknall, Julian'; CHBox:cbChecked;  Suit:0; Simp:'Aries'; Simp2:1; Phone:'1115551111'; Age:38),
    (Name:'Inman, Lee';       CHBox:cbChecked;  Suit:1; Simp:'Aries'; Simp2:2; Phone:'2225552222'; Age:23),
    (Name:'Hughes, Terry';    CHBox:cbChecked;  Suit:2; Simp:'Aries'; Simp2:3; Phone:'3335553333'; Age:24),
    (Name:'Slatner, Bryan';   CHBox:cbChecked;  Suit:3; Simp:'Aries'; Simp2:4; Phone:'4445554444'; Age:25),
    (Name:'Leier, John';      CHBox:cbChecked;  Suit:0; Simp:'Aries'; Simp2:5; Phone:'5555555555'; Age:26),
    (Name:'Frerking, Gary';   CHBox:cbChecked;  Suit:1; Simp:'Aries'; Simp2:6; Phone:'6665556666'; Age:27),
    (Name:'Kokkonen, Kim';    CHBox:cbChecked;  Suit:2; Simp:'Aries'; Simp2:7; Phone:'7775557777'; Age:28),
    (Name:'Vaupel, Larry';    CHBox:cbChecked;  Suit:3; Simp:'Aries'; Simp2:8; Phone:'8885558888'; Age:29),
    (Name:' ';                CHBox:cbChecked;  Suit:0; Simp:'Aries'; Simp2:9; Phone:'9995559999'; Age:0));

procedure TForm1.OvcTable1GetCellData(Sender: TObject;
                                      RowNum: Longint;
                                      ColNum: Integer;
                                      var Data: Pointer);
  var
    BMI : TCellBitMapInfo absolute CellData;
    ColRec : TOvcTableColumn;
  begin
    case ColNum of
      1 : begin
            if RowNum > 0 then
              Data := @TestDatabase[RowNum].Name;
          end;
      2 : begin
            Data := @TestDatabase[RowNum].CHBox;
          end;
      3 : begin
            Data := @TestDatabase[RowNum].Suit;
          end;
      4 : begin
            Data := @TestDatabase[RowNum].Simp;
          end;
      5 : begin
            Data := @TestDatabase[RowNum].Simp2;
          end;
      6 : begin
            Data := @TestDatabase[RowNum].Phone;
          end;
      7 : begin
            Data := @TestDatabase[RowNum].Age;
          end;
    else
      CellData := '?';
      Data := @CellData;
    end;{case}
  end;

procedure TForm1.RowModeClick(Sender: TObject);
begin
  with OvcTable1 do
    if otoBrowseRow in Options then
      Options := Options - [otoBrowseRow]
    else
      Options := Options + [otoBrowseRow]
end;

procedure TForm1.OvcTable1GetCellColor(Sender: TObject; RowNum: Longint;
  ColNum: Integer; var Color: TColor);
begin
  if (RowNum = 9) then
    Color := clLime;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  TempFont : TFont;
begin
  with OvcTable1 do
    begin
      AllowRedraw := false;

      BlockColBegin := 3;
      BlockRowBegin := 2;
      BlockColEnd := 4;
      BlockRowEnd := 4;
      BlockAdjust := otaTopRight;

      BlockColBegin := 0;
      BlockRowBegin := 7;
      BlockColEnd := pred(ColCount);
      BlockRowEnd := 7;
      BlockColor := clGray;

      BlockColBegin := 0;
      BlockRowBegin := 5;
      BlockColEnd := pred(ColCount);
      BlockRowEnd := 5;
      TempFont := TFont.Create;
      TempFont.Assign(Font);
      TempFont.Name := 'Courier New';
      BlockFont := TempFont;
      TempFont.Free;

      BlockColBegin := 6;
      BlockRowBegin := 1;
      BlockColEnd := 6;
      BlockRowEnd := 3;
      BlockCell := OvcTableCellString2;

      AllowRedraw := true;
    end;
end;

end.
